"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.onInitialClientRender = void 0;

var _interopRequireWildcard2 = _interopRequireDefault(require("@babel/runtime/helpers/interopRequireWildcard"));

var React = require('react');

var privateRoute = require('./components/privateRoute').default;

var LoginWrapper = require('./components/loginWrapper').default;

var _require = require('./utils/config'),
    defaultAdminPath = _require.defaultAdminPath; // Taken from https://github.com/netlify/netlify-identity-widget


var routes = /(confirmation|invite|recovery|email_change)_token=([^&]+)/;
var errorRoute = /error=access_denied&error_description=403/;
var accessTokenRoute = /access_token=/;

var onInitialClientRender = function onInitialClientRender(_, pluginOptions) {
  var _pluginOptions$adminP = pluginOptions.adminPath,
      adminPath = _pluginOptions$adminP === void 0 ? defaultAdminPath : _pluginOptions$adminP;
  var enableIdentityWidget = true;
  var hash = (document.location.hash || "").replace(/^#\/?/, "");

  if (enableIdentityWidget && (routes.test(hash) || errorRoute.test(hash) || accessTokenRoute.test(hash))) {
    Promise.resolve().then(function () {
      return (0, _interopRequireWildcard2.default)(require("netlify-identity-widget"));
    }).then(function (_ref) {
      var netlifyIdentityWidget = _ref.default;
      netlifyIdentityWidget.on("init", function (user) {
        if (!user) {
          netlifyIdentityWidget.on("login", function () {
            document.location.href = __PATH_PREFIX__ + "/" + adminPath + "/";
          });
        }
      });
      netlifyIdentityWidget.init();
    });
  }
};

exports.onInitialClientRender = onInitialClientRender;

exports.wrapPageElement = function (_ref2, pluginOptions) {
  var element = _ref2.element,
      props = _ref2.props;
  var loginPath = pluginOptions.loginPath;
  var netlifyAdminPlugin = props.pageContext.netlifyAdminPlugin;

  if (netlifyAdminPlugin) {
    if (netlifyAdminPlugin.shouldExclude) {
      // return loginWrapper(element);
      return /*#__PURE__*/React.createElement(LoginWrapper, {
        element: element
      });
    }

    return privateRoute({
      component: /*#__PURE__*/React.createElement(LoginWrapper, {
        element: element
      }),
      path: props.uri,
      loginPath: loginPath
    });
  }

  return element;
};